require 'fileutils'

def debug(message)
  logger = Logger.new(STDOUT)
  logger.debug ">>>>>>>>>>>>>>>DEBUG START<<<<<<<<<<<<<<<"
  logger.debug message
  logger.debug ">>>>>>>>>>>>>>>DEBUG ENG<<<<<<<<<<<<<<<"
end

def info_to_console(message)
  puts message
end

def error_to_console(message)
  puts "Error: #{message}"
end

def log_to_file(message)
  FileLog.new.info(message)
end

def error_to_file(message)
  FileLog.new.error(message)
end

def info(message)
  info_to_console message
  log_to_file message
end

def error(message)
  error_to_console message
  error_to_file message
end

def run_command(cmd)
  Process.abort "Failed to run command #{cmd}" unless system cmd
end

def reset_dir(dir)
  FileUtils.rm_rf dir if File.exist? dir
  FileUtils.mkdir_p dir  
end

def require_dir(dir)
  Dir.foreach(dir) do |entry|
    absolute_path = File.join(dir, entry)
    next if (entry == "." || entry == "..")
    require absolute_path if (File.file?(absolute_path) && absolute_path.end_with?("rb"))
    require_dir(absolute_path) if File.directory?(absolute_path)
  end
end

def read_all file
  IO.readlines(file).join
end